package com.jeeplus.test.luckyDraw.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.aop.logging.annotation.ApiLog;
import com.jeeplus.common.utils.ResponseUtil;
import com.jeeplus.test.luckyDraw.service.LuckyDrawInfoService;
import com.jeeplus.test.luckyDraw.service.dto.LuckyDrawInfoDto;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * @author: 王强
 * @create: 2023-02-28 11:06
 **/
@RestController
@Api(tags ="抽奖-抽奖")
@RequestMapping(value = "/luckyDraw/info")
public class LuckyDrawInfoController {

    @Resource
    private LuckyDrawInfoService drawInfoService;

    /**
     * 根据活动id查询抽奖信息
     * @param id
     * @return
     */
    @ApiOperation(value = "根据活动id查询抽奖信息")
    @GetMapping("/findByEventId")
    public ResponseEntity<LuckyDrawInfoDto> findByEventId(@RequestParam String id) throws Exception{
        LuckyDrawInfoDto dto = drawInfoService.findByEventId(id);
        return ResponseEntity.ok(dto);
    }

    @ApiLog("活动列表")
    @GetMapping("list")
    public ResponseEntity<IPage<LuckyDrawInfoDto>> data(LuckyDrawInfoDto luckyDrawEventsDTO, Page<LuckyDrawInfoDto> page) throws Exception {
        IPage<LuckyDrawInfoDto> result = new Page<LuckyDrawInfoDto>();
        result = drawInfoService.findList (page,luckyDrawEventsDTO);
        return ResponseEntity.ok (result);
    }

    /**
     * 抽奖
     * @param dto
     * @return
     */
    @ApiOperation(value = "抽奖")
    @PostMapping("/luckyDraw")
    public ResponseEntity<String> luckyDraw(@RequestBody LuckyDrawInfoDto dto) throws Exception{
        String s = drawInfoService.luckyDraw(dto);
        return ResponseUtil.newInstance().ok ("操作成功");
    }

}
